function [B,Omega,epsilon]=favar_estimation(Data,p)
% FAVAR estimation
% p: Number of lags
% Data: TxK 
[T,K] = size(Data);
% Construction of the matrix of regressors
Z = [];
for j=1:p
Z= [Z Data(p+1-j:T-j,:)]; 
end
% Dependent variables
Y= Data(p+1:T,:);
%Regression coefficient estimates
B= (Z'*Z)\(Z'*Y); % B: (p*K)x K 
%Residuals
epsilon= Y-Z*B;
% Variance estimates for the error term
Omega=epsilon'*epsilon/(T-p-p*K);