function [AAA,index,BBB]=identification_with_sign_restrictions_and_inventory(Data,p)
%The code produces the rotated identified matrix AA: (5x5) x m , m<M
% satisfying the sign restrictions

% A: kxk
% B: (pk)xk


[T,k]=size(Data);

%%Construction of the matrix of regressors 
Z = [];
for j=1:p
Z= [Z Data(p+1-j:T-j,:)]; 
end
%Dependent variables
Y= Data(p+1:T,:);

B= (Z'*Z)\(Z'*Y); % B: (p*K)x K 
%Residuals
epsilon= Y-Z*B;
% Variance estimates for the error term
Omega=epsilon'*epsilon/(T-p-p*k);
invZZ=inv((Z'*Z)/(T-p));


M=100000; %Number of draws
N_pos=500; %Number of posterior draws

% Performs a QR decomposition on m-by-n matrix K such that K = Q*R.
% The factor R is an m-by-n upper-triangular matrix, 
% and the factor Q is an m-by-m orthogonal matrix.

AAA=[];
index=0;
BBB=[];
for j=1:N_pos
 
    Draws_POS=randn(T-p,k)/sqrt(T-p)*chol(inv(Omega));
    Omega_POS=inv(Draws_POS'*Draws_POS);
    vecB=reshape(B(1:k,:)',k*k,1);
    for l=1:p-1
       vecB=[vecB; reshape(B(k*l+1:k*(l+1),:)',k*k,1)];   
    end

    vecBB=vecB+(chol(kron(invZZ/(T-p),Omega_POS)))'*randn(k^2*p,1);
	BB=reshape(vecBB(1:k^2*p),k,k*p)'; 
     [V,D]=svd(Omega_POS);
     AA=V*D.^0.5;

for b = 1 : M           
    K=normrnd(0,1,k,k);
    [Q, R] = qr(K, 0);

    for i = 1 : k
        if R(i, i) < 0
            Q(:,i) = -Q(:,i);
        end
    end                 


AA0=AA*Q';
Response_0=AA0;
%Real activity factors
if Response_0(1,1)>0 && Response_0(2,2)>0 && Response_0(3,3)>0 
      if Response_0(1,1)>max(Response_0(2:3,1))&& Response_0(2,2)>max(Response_0(1,2),Response_0(3,2)) && Response_0(3,3)>max(Response_0(1:2,3))
          if min(Response_0(1:3,4:5))<0
    % Oil Production
              if Response_0(4,4)<0 && min(Response_0(4,1:3))>0 && min(Response_0(4,5))>0
       %Inventory
                   if  min(Response_0(5,5))>0
         % Real price of oil
                          if  min(Response_0(6,1:5))>0
                             AAA=[AAA AA0];
                             index=index+1;
                             BBB=[BBB BB];
                          end
                    end
              end
          end
      end
end

end % End sign restriction draws
end % End posterior draws
end