function []=plot_IRF_Z_with_inventory(IRF_Z,IRF_Z_lower,IRF_Z_upper,H)
% Plot Figures C22, C23, C24 and C25 in Online Appendix C

horizon=0:H;

figure('name','Unobserved factors 1')

subplot(3,3,1)
plot(horizon,IRF_Z(:,1,1),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,1,1)' flip(IRF_Z_upper(:,1,1)')],'k','facealpha',0.1,'LineStyle','none')
title('Flow global demand')
ylabel('$\hat{f}_{0t}$','Interpreter','latex')

subplot(3,3,2)
plot(horizon,IRF_Z(:,1,2),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,1,2)' flip(IRF_Z_upper(:,1,2)')],'k','facealpha',0.1,'LineStyle','none')
title('Flow developed demand')

subplot(3,3,3)
plot(horizon,IRF_Z(:,1,3),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,1,3)' flip(IRF_Z_upper(:,1,3)')],'k','facealpha',0.1,'LineStyle','none')
title('Flow emerging demand')

subplot(3,3,4)
plot(horizon,IRF_Z(:,2,1),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,2,1)' flip(IRF_Z_upper(:,2,1)')],'k','facealpha',0.1,'LineStyle','none')
ylabel('$\hat{f}_{Dt}$','Interpreter','latex')

subplot(3,3,5)
plot(horizon,IRF_Z(:,2,2),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,2,2)' flip(IRF_Z_upper(:,2,2)')],'k','facealpha',0.1,'LineStyle','none')


subplot(3,3,6)
plot(horizon,IRF_Z(:,2,3),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,2,3)' flip(IRF_Z_upper(:,2,3)')],'k','facealpha',0.1,'LineStyle','none')

subplot(3,3,7)
plot(horizon,IRF_Z(:,3,1),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,3,1)' flip(IRF_Z_upper(:,3,1)')],'k','facealpha',0.1,'LineStyle','none')
ylabel('$\hat{f}_{Et}$','Interpreter','latex')

subplot(3,3,8)
plot(horizon,IRF_Z(:,3,2),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,3,2)' flip(IRF_Z_upper(:,3,2)')],'k','facealpha',0.1,'LineStyle','none')

subplot(3,3,9)
plot(horizon,IRF_Z(:,3,3),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,3,3)' flip(IRF_Z_upper(:,3,3)')],'k','facealpha',0.1,'LineStyle','none')

set(gcf, 'PaperPosition', [0 0 14 8]); %Position plot at left hand corner with width 14 and height 8.
set(gcf, 'PaperSize', [14 8]); %Set the paper to have width 14 and height 8.
saveas(gcf, 'FigureC22', 'pdf') %Save figure
hold off


figure('name','Unobserved factors 2')
subplot(3,2,1)
plot(horizon,IRF_Z(:,1,4),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,1,4)' flip(IRF_Z_upper(:,1,4)')],'k','facealpha',0.1,'LineStyle','none')
title('Flow oil supply')
ylabel('$\hat{f}_{0t}$','Interpreter','latex')

subplot(3,2,2)
plot(horizon,IRF_Z(:,1,5),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,1,5)' flip(IRF_Z_upper(:,1,5)')],'k','facealpha',0.1,'LineStyle','none')
title('Speculative demand')

subplot(3,2,3)
plot(horizon,IRF_Z(:,2,4),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,2,4)' flip(IRF_Z_upper(:,2,4)')],'k','facealpha',0.1,'LineStyle','none')
ylabel('$\hat{f}_{Dt}$','Interpreter','latex')

subplot(3,2,4)
plot(horizon,IRF_Z(:,2,5),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,2,5)' flip(IRF_Z_upper(:,2,5)')],'k','facealpha',0.1,'LineStyle','none')

subplot(3,2,5)
plot(horizon,IRF_Z(:,3,4),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,3,4)' flip(IRF_Z_upper(:,3,4)')],'k','facealpha',0.1,'LineStyle','none')
ylabel('$\hat{f}_{Et}$','Interpreter','latex')

subplot(3,2,6)
plot(horizon,IRF_Z(:,3,5),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,3,5)' flip(IRF_Z_upper(:,3,5)')],'k','facealpha',0.1,'LineStyle','none')

set(gcf, 'PaperPosition', [0 0 14 8]); %Position plot at left hand corner with width 14 and height 8.
set(gcf, 'PaperSize', [14 8]); %Set the paper to have width 14 and height 8.
saveas(gcf, 'FigureC23', 'pdf') %Save figure
hold off


figure('name','Observed factors 1')

subplot(3,3,1)
plot(horizon,IRF_Z(:,4,1),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,4,1)' flip(IRF_Z_upper(:,4,1)')],'k','facealpha',0.1,'LineStyle','none')
title('Flow global demand')
ylabel('$g_{1t}$','Interpreter','latex')

subplot(3,3,2)
plot(horizon,IRF_Z(:,4,2),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,4,2)' flip(IRF_Z_upper(:,4,2)')],'k','facealpha',0.1,'LineStyle','none')
title('Flow developed demand')

subplot(3,3,3)
plot(horizon,IRF_Z(:,4,3),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,4,3)' flip(IRF_Z_upper(:,4,3)')],'k','facealpha',0.1,'LineStyle','none')
title('Flow emerging demand')

subplot(3,3,4)
plot(horizon,IRF_Z(:,5,1),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,5,1)' flip(IRF_Z_upper(:,5,1)')],'k','facealpha',0.1,'LineStyle','none')
ylabel('$g_{2t}$','Interpreter','latex')

subplot(3,3,5)
plot(horizon,IRF_Z(:,5,2),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,5,2)' flip(IRF_Z_upper(:,5,2)')],'k','facealpha',0.1,'LineStyle','none')

subplot(3,3,6)
plot(horizon,IRF_Z(:,5,3),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,5,3)' flip(IRF_Z_upper(:,5,3)')],'k','facealpha',0.1,'LineStyle','none')

subplot(3,3,7)
plot(horizon,IRF_Z(:,6,1),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,6,1)' flip(IRF_Z_upper(:,6,1)')],'k','facealpha',0.1,'LineStyle','none')
ylabel('$g_{3t}$','Interpreter','latex')

subplot(3,3,8)
plot(horizon,IRF_Z(:,6,2),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,6,2)' flip(IRF_Z_upper(:,6,2)')],'k','facealpha',0.1,'LineStyle','none')

subplot(3,3,9)
plot(horizon,IRF_Z(:,6,3),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,6,3)' flip(IRF_Z_upper(:,6,3)')],'k','facealpha',0.1,'LineStyle','none')

set(gcf, 'PaperPosition', [0 0 14 8]); %Position plot at left hand corner with width 14 and height 8.
set(gcf, 'PaperSize', [14 8]); %Set the paper to have width 14 and height 8.
saveas(gcf, 'FigureC24', 'pdf') %Save figure
hold off


 
figure('name','Observed factors 2')

subplot(3,2,1)
plot(horizon,IRF_Z(:,4,4),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,4,4)' flip(IRF_Z_upper(:,4,4)')],'k','facealpha',0.1,'LineStyle','none')
title('Flow oil supply')
ylabel('$g_{1t}$','Interpreter','latex')

subplot(3,2,2)
plot(horizon,IRF_Z(:,4,5),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,4,5)' flip(IRF_Z_upper(:,4,5)')],'k','facealpha',0.1,'LineStyle','none')
title('Speculative demand')

subplot(3,2,3)
plot(horizon,IRF_Z(:,5,4),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,5,4)' flip(IRF_Z_upper(:,5,4)')],'k','facealpha',0.1,'LineStyle','none')
ylabel('$g_{2t}$','Interpreter','latex')

subplot(3,2,4)
plot(horizon,IRF_Z(:,5,5),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,5,5)' flip(IRF_Z_upper(:,5,5)')],'k','facealpha',0.1,'LineStyle','none')

subplot(3,2,5)
plot(horizon,IRF_Z(:,6,4),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,6,4)' flip(IRF_Z_upper(:,6,4)')],'k','facealpha',0.1,'LineStyle','none')
ylabel('$g_{3t}$','Interpreter','latex')

subplot(3,2,6)
plot(horizon,IRF_Z(:,6,5),'k',horizon,zeros(size(horizon)),'k:','LineWidth',1.5)
hold on
fill([horizon flip(horizon)],[IRF_Z_lower(:,6,5)' flip(IRF_Z_upper(:,6,5)')],'k','facealpha',0.1,'LineStyle','none')

set(gcf, 'PaperPosition', [0 0 14 8]); %Position plot at left hand corner with width 14 and height 8.
set(gcf, 'PaperSize', [14 8]); %Set the paper to have width 14 and height 8.
saveas(gcf, 'FigureC25', 'pdf') %Save figure
hold off

end